
c These are subroutines originally written for skyring2mosaic.f

c subroutine for opening a mosaic image

      subroutine openmosaicimage(basename,nchips,imptr,ierr)

      integer imptr(nchips),nchips,ierr
      character basename*80,imname*100,suffix*2

c find end of basename. Image names with spaces will cause heartache!
 10   ilen = index(basename,' ')-1
c IMACS format: images are basenamec1.fits, etc.
c NOAO mosaic multi-fits-extension format would require changes
c only accomodates 1..9 chips at moment
      ifanyerr = 0
 20   do i=1,nchips
         write(suffix,'(a1,i1)') 'c',i
         imname = basename(1:ilen) // suffix
         call imopen(imname,1,imptr(i),ierr)
         if (ierr .ne. 0) then
            write(*,'("mosimagesubs: error opening FITS file ",a30)')
     $           imname
            write(*,'("mosimagesubs: skipping subsequent chips")')
            ifanyerr=1
            ierr = 0
            go to 30
         end if
      end do
 30   ierr=ifanyerr
      return
      end

c create a new image that's the same size as the old, like imopnc
c this always generates warnings about the header, which are harmless
      subroutine opncmosaicimage(newbasename,nchips,imold,imnew,ierr)

      integer imold(nchips),imnew(nchips)
      character newbasename*80,imname*100,suffix*2

c find end of basename. Image names with spaces will cause heartache!
 10   ilen = index(newbasename,' ')-1
c IMACS format: images are basenamec1.fits, etc.
      ifanyerr = 0
 20   do i=1,nchips
         write(suffix,'(a1,i1)') 'c',i
         imname = newbasename(1:ilen) // suffix
         call imopnc(imname,imold(i),imnew(i),ierr)
         if (ierr .ne. 0) then
            write(*,'("mosimagesubs: error opening FITS file ",a30)')
     $           imname
            write(*,'("mosimagesubs: skipping subsequent chips")')
            ifanyerr=1
            ierr = 0
            go to 30
         end if
      end do
 30   ierr=ifanyerr
      return
      end
       

c subr for closing a mosaic image
      subroutine closemosaicimage(nchips,imptr,ierr)

      integer imptr(nchips)
      
 10   ifanyerr=0
 20   do i=1,nchips
         call imclos(imptr(i),ierr)
         if (ierr .ne. 0) then
            write(*,'
     $           ("mosimagesubs: error closing image for CCD chip
     $           #",i1,".")') i
            write(*,'("mosimagesubs: skipping subsequent chips")')
            ierr = 0
            ifanyerr = 1
            go to 30
         endif
      end do
 30   ierr = ifanyerr
      return
      end
